// ============================================================================
// ==                                                                        ==
// == Amdis - Adaptive multidimensional simulations                          ==
// ==                                                                        ==
// ==  http://www.amdis-fem.org                                              ==
// ==                                                                        ==
// ============================================================================
//
// Software License for AMDiS
//
// Copyright (c) 2010 Dresden University of Technology 
// All rights reserved.
// Authors: Simon Vey, Thomas Witkowski et al.
//
// This file is part of AMDiS
//
// See also license.opensource.txt in the distribution.



/** \file ArhWriter.h */

#ifndef AMDIS_ARH_WRITER_H
#define AMDIS_ARH_WRITER_H

#include <iostream>
#include <fstream>

#include "AMDiS_fwd.h"

namespace AMDiS {

  class ArhWriter
  {
  public:
    static void write(std::string filename, Mesh *mesh);

    static void write(std::string filename, Mesh *mesh, DOFVector<double>* vec);

    static void write(std::string filename, Mesh *mesh, 
		      std::vector<DOFVector<double>*> vecs);

  protected:
    static void writeMacroElement(std::ofstream &file, 
				  MeshStructure &code, 
				  std::vector<std::vector<double> >& values,
				  int32_t elIndex);
  };
}

#endif
